diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/radiotap-header.h ns-3.46/src/network/utils/radiotap-header.h
--- ns-3.45/src/network/utils/radiotap-header.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/radiotap-header.h	2025-10-01 18:46:32.000000000 -0700
@@ -83,6 +83,14 @@
     void Print(std::ostream& os) const override;
 
     /**
+     * @brief Set the ieee80211_radiotap_header. This method must be called
+     * before any other Set* method.
+     *
+     * @param numPresentWords Number of it_present words in the radiotap header.
+     */
+    void SetWifiHeader(std::size_t numPresentWords);
+
+    /**
      * @brief Set the Time Synchronization Function Timer (TSFT) value.  Valid for
      * received frames only.
      *
@@ -773,6 +781,25 @@
     void SetEhtFields(const EhtFields& ehtFields);
 
   private:
+    static constexpr int MIN_HEADER_SIZE{8}; //!< the minimum size of the radiotap header
+
+    /**
+     * Serialize the TSFT radiotap header.
+     *
+     * @param start An iterator which points to where the header should be written.
+     */
+    void SerializeTsft(Buffer::Iterator& start) const;
+
+    /**
+     * Deserialize the TSFT radiotap header.
+     *
+     * @param start An iterator which points to where the header should be read.
+     * @param bytesRead the number of bytes already read.
+
+     * @returns The number of bytes read.
+     */
+    uint32_t DeserializeTsft(Buffer::Iterator start, uint32_t bytesRead);
+
     /**
      * Serialize the Channel radiotap header.
      *
@@ -1031,12 +1058,12 @@
         RADIOTAP_EHT_SIG = 0x00000004
     };
 
-    uint16_t m_length{8};                   //!< entire length of radiotap data + header
-    uint32_t m_present{0};                  //!< bits describing which fields follow header
-    std::optional<uint32_t> m_presentExt{}; //!< optional extended present bitmask
+    uint16_t m_length{MIN_HEADER_SIZE}; //!< entire length of radiotap data + header
+    std::vector<uint32_t> m_present{0}; //!< bits describing which fields follow header
 
-    uint64_t m_tsft{0}; //!< Time Synchronization Function Timer (when the first bit of the MPDU
-                        //!< arrived at the MAC)
+    uint8_t m_tsftPad{0}; //!< TSFT padding.
+    uint64_t m_tsft{0};   //!< Time Synchronization Function Timer (when the first bit of the MPDU
+                          //!< arrived at the MAC)
 
     uint8_t m_flags{FRAME_FLAG_NONE}; //!< Properties of transmitted and received frames.
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/olsr/examples/olsr-hna.cc ns-3.46/src/olsr/examples/olsr-hna.cc
--- ns-3.45/src/olsr/examples/olsr-hna.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/olsr/examples/olsr-hna.cc	2025-10-01 18:46:32.000000000 -0700
@@ -237,7 +237,7 @@
     {
         // Create a special Ipv4StaticRouting instance for RoutingTableAssociation
         // Even the Ipv4StaticRouting instance added to list may be used
-        Ptr<Ipv4StaticRouting> hnaEntries = Create<Ipv4StaticRouting>();
+        Ptr<Ipv4StaticRouting> hnaEntries = CreateObject<Ipv4StaticRouting>();
 
         // Add the required routes into the Ipv4StaticRouting Protocol instance
         // and have the node generate HNA messages for all these routes
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/olsr/model/olsr-routing-protocol.cc ns-3.46/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.45/src/olsr/model/olsr-routing-protocol.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/olsr/model/olsr-routing-protocol.cc	2025-10-01 18:46:32.000000000 -0700
@@ -252,7 +252,7 @@
 {
     m_uniformRandomVariable = CreateObject<UniformRandomVariable>();
 
-    m_hnaRoutingTable = Create<Ipv4StaticRouting>();
+    m_hnaRoutingTable = CreateObject<Ipv4StaticRouting>();
 }
 
 RoutingProtocol::~RoutingProtocol()
@@ -3032,6 +3032,7 @@
         NS_LOG_LOGIC("No dynamic route, check network routes");
         if (m_hnaRoutingTable->RouteInput(p, header, idev, ucb, mcb, lcb, ecb))
         {
+            // NOLINTNEXTLINE(readability-simplify-boolean-expr)
             return true;
         }
         else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/model/channel-condition-model.cc ns-3.46/src/propagation/model/channel-condition-model.cc
--- ns-3.45/src/propagation/model/channel-condition-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/model/channel-condition-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -983,4 +983,4 @@
     return SuburbanRuralLOSProb.at(quantizedElevAngle);
 }
 
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/model/probabilistic-v2v-channel-condition-model.cc ns-3.46/src/propagation/model/probabilistic-v2v-channel-condition-model.cc
--- ns-3.45/src/propagation/model/probabilistic-v2v-channel-condition-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/model/probabilistic-v2v-channel-condition-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -228,4 +228,4 @@
     return pNlos;
 }
 
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/model/propagation-loss-model.cc ns-3.46/src/propagation/model/propagation-loss-model.cc
--- ns-3.45/src/propagation/model/propagation-loss-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/model/propagation-loss-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,6 +15,7 @@
 #include "ns3/double.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
+#include "ns3/node.h"
 #include "ns3/pointer.h"
 #include "ns3/string.h"
 
@@ -863,7 +864,8 @@
 {
     NS_ASSERT(ma && mb);
 
-    MobilityPair p = std::make_pair(ma, mb);
+    uint64_t p = ((uint64_t)ma->GetObject<Node>()->GetId()) << 32 |
+                 ((uint64_t)mb->GetObject<Node>()->GetId());
     auto i = m_loss.find(p);
 
     if (i == m_loss.end())
@@ -886,7 +888,9 @@
                                           Ptr<MobilityModel> a,
                                           Ptr<MobilityModel> b) const
 {
-    auto i = m_loss.find(std::make_pair(a, b));
+    uint64_t p =
+        ((uint64_t)a->GetObject<Node>()->GetId()) << 32 | ((uint64_t)b->GetObject<Node>()->GetId());
+    auto i = m_loss.find(p);
 
     if (i != m_loss.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/model/propagation-loss-model.h ns-3.46/src/propagation/model/propagation-loss-model.h
--- ns-3.45/src/propagation/model/propagation-loss-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/model/propagation-loss-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -734,30 +734,7 @@
 
     double m_default; //!< default loss
 
-    /// Typedef: Mobility models pair
-    typedef std::pair<const Ptr<MobilityModel>, const Ptr<MobilityModel>> MobilityPair;
-
-    /**
-     * @ingroup propagation
-     *
-     * @brief Hasher for a pair of mobility models.
-     */
-    class MobilityPairHasher
-    {
-      public:
-        /**
-         * @brief Get the hash for a MobilityPair.
-         * @param key MobilityPair reference to hash
-         * @return the MobilityPair hash
-         */
-        size_t operator()(const MobilityPair& key) const
-        {
-            return uint64_t(key.first.operator->()) ^ uint64_t(key.second.operator->());
-        }
-    };
-
-    std::unordered_map<MobilityPair, double, MobilityPairHasher>
-        m_loss; //!< Propagation loss between pair of nodes
+    std::unordered_map<uint64_t, double> m_loss; //!< Propagation loss between pair of nodes
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.45/src/propagation/model/three-gpp-propagation-loss-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -263,9 +263,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppPropagationLossModel);
 
-std::function<Ptr<MobilityModel>(Ptr<const MobilityModel>, Ptr<const MobilityModel>)>
-    ThreeGppPropagationLossModel::m_doCalcRxPowerPrologueFunction;
-
 TypeId
 ThreeGppPropagationLossModel::GetTypeId()
 {
@@ -378,19 +375,11 @@
 
 double
 ThreeGppPropagationLossModel::DoCalcRxPower(double txPowerDbm,
-                                            Ptr<MobilityModel> c,
+                                            Ptr<MobilityModel> a,
                                             Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
-    // if there is a prologue function installed, call it and replace the transmitter mobility model
-    auto a = m_doCalcRxPowerPrologueFunction ? m_doCalcRxPowerPrologueFunction(b, c) : c;
-    if (a->GetPosition() != c->GetPosition())
-    {
-        NS_LOG_DEBUG("Prologue function replaced source position "
-                     << c->GetPosition() << " with position " << a->GetPosition());
-    }
-
     // check if the model is initialized
     NS_ASSERT_MSG(m_frequency != 0.0, "First set the centre frequency");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/model/three-gpp-propagation-loss-model.h ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.h
--- ns-3.45/src/propagation/model/three-gpp-propagation-loss-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/model/three-gpp-propagation-loss-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -75,26 +75,6 @@
      */
     bool IsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const;
 
-    /**
-     * @brief Stop-gap solution for wraparound model
-     *
-     * Stop-gap solution for support of wraparound model in the 5G NR module. This
-     * method was introduced for ns-3.45 but will be removed in a future release once
-     * a more general solution is added elsewhere (most likely in the spectrum channel). The
-     * callback method registered here will be executed at the beginning of DoCalcRxPower, and the
-     * returned pointer to a mobility model will be subsequently used as the (replacement) source
-     * mobility model for the rest of DoCalcRxPower() processing.
-     *
-     * @param prologueFunction Function that receives two mobility models and compute a third, based
-     * on the wrapped position of the second model in respect to the first
-     */
-    static void InstallDoCalcRxPowerPrologueFunction(
-        std::function<Ptr<MobilityModel>(Ptr<const MobilityModel>, Ptr<const MobilityModel>)>
-            prologueFunction)
-    {
-        m_doCalcRxPowerPrologueFunction = prologueFunction;
-    }
-
   private:
     /**
      * Computes the received power by applying the pathloss model described in
@@ -320,10 +300,6 @@
     Ptr<NormalRandomVariable>
         m_normalO2iHighLossVar; //!< a normal random variable for the calculation of 02i high loss,
                                 //!< see TR38.901 Table 7.4.3-2
-
-    /// Optional prologue function that can be used to implement wraparound models
-    static std::function<Ptr<MobilityModel>(Ptr<const MobilityModel>, Ptr<const MobilityModel>)>
-        m_doCalcRxPowerPrologueFunction;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/propagation/test/propagation-loss-model-test-suite.cc ns-3.46/src/propagation/test/propagation-loss-model-test-suite.cc
--- ns-3.45/src/propagation/test/propagation-loss-model-test-suite.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/propagation/test/propagation-loss-model-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
@@ -9,6 +9,7 @@
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/double.h"
 #include "ns3/log.h"
+#include "ns3/node-container.h"
 #include "ns3/propagation-loss-model.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
@@ -407,10 +408,12 @@
 void
 MatrixPropagationLossModelTestCase::DoRun()
 {
+    NodeContainer nc(3);
     Ptr<MobilityModel> m[3];
     for (int i = 0; i < 3; ++i)
     {
         m[i] = CreateObject<ConstantPositionMobilityModel>();
+        nc.Get(i)->AggregateObject(m[i]);
     }
 
     MatrixPropagationLossModel loss;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/CMakeLists.txt ns-3.46/src/spectrum/CMakeLists.txt
--- ns-3.45/src/spectrum/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -10,12 +10,13 @@
     model/friis-spectrum-propagation-loss.cc
     model/half-duplex-ideal-phy-signal-parameters.cc
     model/half-duplex-ideal-phy.cc
+    model/hexagonal-wraparound-model.cc
     model/ism-spectrum-value-helper.cc
     model/matrix-based-channel-model.cc
     model/microwave-oven-spectrum-value-helper.cc
-    model/two-ray-spectrum-propagation-loss-model.cc
     model/multi-model-spectrum-channel.cc
     model/non-communicating-net-device.cc
+    model/phased-array-spectrum-propagation-loss-model.cc
     model/single-model-spectrum-channel.cc
     model/spectrum-analyzer.cc
     model/spectrum-channel.cc
@@ -27,15 +28,16 @@
     model/spectrum-model.cc
     model/spectrum-phy.cc
     model/spectrum-propagation-loss-model.cc
-    model/spectrum-transmit-filter.cc
-    model/phased-array-spectrum-propagation-loss-model.cc
     model/spectrum-signal-parameters.cc
+    model/spectrum-transmit-filter.cc
     model/spectrum-value.cc
     model/three-gpp-channel-model.cc
     model/three-gpp-spectrum-propagation-loss-model.cc
     model/trace-fading-loss-model.cc
     model/tv-spectrum-transmitter.cc
+    model/two-ray-spectrum-propagation-loss-model.cc
     model/waveform-generator.cc
+    model/wraparound-model.cc
 )
 
 set(header_files
@@ -50,12 +52,13 @@
     model/friis-spectrum-propagation-loss.h
     model/half-duplex-ideal-phy-signal-parameters.h
     model/half-duplex-ideal-phy.h
+    model/hexagonal-wraparound-model.h
     model/ism-spectrum-value-helper.h
     model/matrix-based-channel-model.h
     model/microwave-oven-spectrum-value-helper.h
-    model/two-ray-spectrum-propagation-loss-model.h
     model/multi-model-spectrum-channel.h
     model/non-communicating-net-device.h
+    model/phased-array-spectrum-propagation-loss-model.h
     model/single-model-spectrum-channel.h
     model/spectrum-analyzer.h
     model/spectrum-channel.h
@@ -67,26 +70,28 @@
     model/spectrum-model.h
     model/spectrum-phy.h
     model/spectrum-propagation-loss-model.h
-    model/spectrum-transmit-filter.h
-    model/phased-array-spectrum-propagation-loss-model.h
     model/spectrum-signal-parameters.h
+    model/spectrum-transmit-filter.h
     model/spectrum-value.h
     model/three-gpp-channel-model.h
     model/three-gpp-spectrum-propagation-loss-model.h
     model/trace-fading-loss-model.h
     model/tv-spectrum-transmitter.h
+    model/two-ray-spectrum-propagation-loss-model.h
     model/waveform-generator.h
-    test/spectrum-test.h
+    model/wraparound-model.h
+    utils/spectrum-test.h
 )
 
 build_lib(
   LIBNAME spectrum
   SOURCE_FILES ${source_files}
   HEADER_FILES ${header_files}
-  LIBRARIES_TO_LINK ${libpropagation}
-                    ${libantenna}
+  LIBRARIES_TO_LINK
+    ${libpropagation}
+    ${libantenna}
+    ${libbuildings}
   TEST_SOURCES
-    test/two-ray-splm-test-suite.cc
     test/spectrum-ideal-phy-test.cc
     test/spectrum-interference-test.cc
     test/spectrum-value-test.cc
@@ -94,4 +99,6 @@
     test/three-gpp-channel-test-suite.cc
     test/tv-helper-distribution-test.cc
     test/tv-spectrum-transmitter-test.cc
+    test/two-ray-splm-test-suite.cc
+    test/wraparound-model-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/hexagonal-wraparound-model.cc ns-3.46/src/spectrum/model/hexagonal-wraparound-model.cc
--- ns-3.45/src/spectrum/model/hexagonal-wraparound-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/spectrum/model/hexagonal-wraparound-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,140 @@
+/*
+ * Copyright (c) 2025 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ */
+
+#include "hexagonal-wraparound-model.h"
+
+#include "ns3/log.h"
+
+#include <algorithm>
+
+constexpr double M_SQRT3 = 1.732050807568877; // sqrt(3)
+
+namespace ns3
+{
+/**
+ * Coefficients used to wraparound a cluster with 7 sites (1 ring)
+ */
+std::vector<Vector2D> WRAPPING_COEFF_CLUSTER7 =
+    {{0.0, 0.0}, {-3.0, 2.0}, {3.0, -2.0}, {-1.5, -2.5}, {1.5, 2.5}, {-4.5, -0.5}, {4.5, 0.5}};
+
+/**
+ * Coefficients used to wraparound a cluster with 19 sites (3 rings)
+ */
+std::vector<Vector2D> WRAPPING_COEFF_CLUSTER19 =
+    {{0.0, 0.0}, {-3.0, -4.0}, {3.0, 4.0}, {-4.5, 3.5}, {4.5, -3.5}, {-7.5, -0.5}, {7.5, 0.5}};
+
+NS_LOG_COMPONENT_DEFINE("HexagonalWraparoundModel");
+
+NS_OBJECT_ENSURE_REGISTERED(HexagonalWraparoundModel);
+
+TypeId
+HexagonalWraparoundModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::HexagonalWraparoundModel")
+                            .SetParent<WraparoundModel>()
+                            .SetGroupName("Spectrum")
+                            .AddConstructor<HexagonalWraparoundModel>();
+    return tid;
+}
+
+HexagonalWraparoundModel::HexagonalWraparoundModel()
+    : m_numSites(1)
+{
+}
+
+HexagonalWraparoundModel::HexagonalWraparoundModel(double isd, size_t numSites)
+    : m_numSites(numSites)
+{
+    SetSiteDistance(isd);
+}
+
+void
+HexagonalWraparoundModel::SetSiteDistance(double isd)
+{
+    m_isd = isd;
+    m_radius = isd / M_SQRT3;
+}
+
+void
+HexagonalWraparoundModel::SetNumSites(uint8_t numSites)
+{
+    NS_ASSERT((numSites == 1) || (numSites == 7) || (numSites == 19));
+    m_numSites = numSites;
+}
+
+void
+HexagonalWraparoundModel::AddSitePosition(const Vector3D& pos)
+{
+    NS_LOG_FUNCTION(this << pos);
+    NS_ASSERT(m_sitePositions.size() < m_numSites);
+    m_sitePositions.push_back(pos);
+}
+
+void
+HexagonalWraparoundModel::SetSitePositions(const std::vector<Vector3D>& positions)
+{
+    NS_ASSERT(positions.size() == m_numSites);
+    m_sitePositions = positions;
+}
+
+double
+HexagonalWraparoundModel::CalculateDistance(const Vector3D& a, const Vector3D& b) const
+{
+    return (a - GetVirtualPosition(b, a)).GetLength();
+}
+
+// Wraparound calculation is based on
+// R. S. Panwar and K. M. Sivalingam, "Implementation of wrap
+// around mechanism for system level simulation of LTE cellular
+// networks in NS3," 2017 IEEE 18th International Symposium on
+// A World of Wireless, Mobile and Multimedia Networks (WoWMoM),
+// Macau, 2017, pp. 1-9, doi: 10.1109/WoWMoM.2017.7974289.
+Vector3D
+HexagonalWraparoundModel::GetSitePosition(const Vector3D& pos) const
+{
+    NS_ASSERT(m_numSites == m_sitePositions.size());
+
+    std::vector<double> virtDists;
+    virtDists.resize(m_numSites);
+    std::transform(m_sitePositions.begin(),
+                   m_sitePositions.end(),
+                   virtDists.begin(),
+                   [&](const Vector3D& sitePos) {
+                       return (this->GetVirtualPosition(pos, sitePos) - sitePos).GetLength();
+                   });
+    auto idx = std::min_element(virtDists.begin(), virtDists.end()) - virtDists.begin();
+    return m_sitePositions[idx];
+}
+
+Vector3D
+HexagonalWraparoundModel::GetVirtualPosition(const Vector3D txPos, const Vector3D rxPos) const
+{
+    NS_ASSERT_MSG((m_numSites == 1) || (m_numSites == 7) || (m_numSites == 19),
+                  "invalid numSites: " << m_numSites);
+
+    if (m_numSites == 1)
+    {
+        return txPos;
+    }
+
+    auto& coeffs = (m_numSites == 7) ? WRAPPING_COEFF_CLUSTER7 : WRAPPING_COEFF_CLUSTER19;
+
+    std::vector<double> virtDists;
+    virtDists.resize(coeffs.size());
+    std::transform(coeffs.begin(), coeffs.end(), virtDists.begin(), [&](const Vector2D& coeff) {
+        Vector3D virtPos2 = txPos;
+        virtPos2.x += coeff.x * m_radius;
+        virtPos2.y += coeff.y * m_isd;
+        return static_cast<double>((virtPos2 - rxPos).GetLength());
+    });
+
+    auto idx = std::min_element(virtDists.begin(), virtDists.end()) - virtDists.begin();
+    Vector3D offset(m_radius * coeffs[idx].x, m_isd * coeffs[idx].y, 0.0);
+    return txPos + offset;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/hexagonal-wraparound-model.h ns-3.46/src/spectrum/model/hexagonal-wraparound-model.h
--- ns-3.45/src/spectrum/model/hexagonal-wraparound-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/spectrum/model/hexagonal-wraparound-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,120 @@
+/*
+ * Copyright (c) 2025 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ */
+
+#ifndef HEXAGONAL_WRAPAROUND_H
+#define HEXAGONAL_WRAPAROUND_H
+
+#include "wraparound-model.h"
+
+#include "ns3/vector.h"
+
+#include <map>
+#include <vector>
+
+namespace ns3
+{
+/**
+ * @ingroup propagation
+ * @brief Hexagonal wraparound model wraps nodes around in space based on an
+ * hexagonal deployment. It is used to determine a virtual position after
+ * wraparound and calculate the distance between a point of reference and
+ * the virtual position.
+ *
+ * This model is used for the hexagonal deployments typical of mobile networks.
+ * It supports rings 0 (1 site), 1 (7 sites) and 3 rings (19 sites).
+ * To use it, set the inter-site distance (isd) and the number of sites.
+ * Then, add the position coordinates of the sites.
+ * All space coordinates in this class and its subclasses are understood
+ * to be meters or meters/s. i.e., they are all metric international units.
+ *
+ * When GetRelativeVirtualPosition (absPos1, absPos2) is called,
+ * the relative position of the absPos2 is calculated respective to the
+ * reference coordinate absPos1, applying the wrapping based on the model
+ * described in:
+ *
+ * R. S. Panwar and K. M. Sivalingam, "Implementation of wrap
+ * around mechanism for system level simulation of LTE cellular
+ * networks in NS3," 2017 IEEE 18th International Symposium on
+ * A World of Wireless, Mobile and Multimedia Networks (WoWMoM),
+ * Macau, 2017, pp. 1-9, doi: 10.1109/WoWMoM.2017.7974289.
+ */
+class HexagonalWraparoundModel : public WraparoundModel
+{
+  public:
+    /**
+     * Register this type with the TypeId system.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * @brief Default constructor
+     */
+    HexagonalWraparoundModel();
+
+    /**
+     * @brief Constructor
+     * @param isd inter-site distance
+     * @param numSites number of sites
+     */
+    HexagonalWraparoundModel(double isd, size_t numSites);
+
+    /**
+     * @brief Set site distance
+     * @param isd site distance
+     */
+    void SetSiteDistance(double isd);
+
+    /**
+     * @brief Set number of sites
+     * @param numSites number of sites
+     */
+    void SetNumSites(uint8_t numSites);
+
+    /**
+     * @brief Add a site position
+     * @param pos position of a site
+     */
+    void AddSitePosition(const Vector3D& pos);
+
+    /**
+     * @brief Set site positions
+     * @param positions positions of all sites
+     */
+    void SetSitePositions(const std::vector<Vector3D>& positions);
+
+    /**
+     * @brief Calculate the site position
+     * @param pos original position
+     * @return closest cell center based on wraparound distance
+     */
+    Vector3D GetSitePosition(const Vector3D& pos) const;
+
+    /**
+     * @brief Calculate distance after wraparound between two points
+     * @param a position of point a
+     * @param b position of point b
+     * @return wraparound distance between a and b
+     */
+    double CalculateDistance(const Vector3D& a, const Vector3D& b) const;
+    /**
+     * @brief Get virtual position of txPos with respect to rxPos
+     * @param txPos
+     * @param rxPos
+     * @return virtual position of txPos
+     */
+    Vector3D GetVirtualPosition(const Vector3D txPos, const Vector3D rxPos) const override;
+
+  private:
+    double m_isd;                          //!< distance between sites
+    double m_radius;                       //!< site radius
+    uint8_t m_numSites;                    //!< number of sites
+    std::vector<Vector3D> m_sitePositions; //!< site positions
+};
+} // namespace ns3
+
+#endif /* HEXAGONAL_WRAPAROUND_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.46/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.45/src/spectrum/model/multi-model-spectrum-channel.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/model/multi-model-spectrum-channel.cc	2025-10-01 18:46:32.000000000 -0700
@@ -12,6 +12,7 @@
 #include "spectrum-phy.h"
 #include "spectrum-propagation-loss-model.h"
 #include "spectrum-transmit-filter.h"
+#include "wraparound-model.h"
 
 #include "ns3/angles.h"
 #include "ns3/antenna-model.h"
@@ -225,7 +226,9 @@
                                            // potential underlying DynamicCasts)
     m_txSigParamsTrace(txParamsTrace);
 
-    auto txMobility = txParams->txPhy->GetMobility();
+    auto wraparound = GetObject<WraparoundModel>();
+    auto refTxMobility = txParams->txPhy->GetMobility();
+    auto txMobility = refTxMobility;
     const auto txSpectrumModelUid = txParams->psd->GetSpectrumModelUid();
     NS_LOG_LOGIC("txSpectrumModelUid " << txSpectrumModelUid);
 
@@ -321,6 +324,14 @@
 
                 if (txMobility && receiverMobility)
                 {
+                    if (wraparound)
+                    {
+                        // Use virtual mobility model instead
+                        txMobility =
+                            wraparound->GetVirtualMobilityModel(refTxMobility, receiverMobility);
+                    }
+                    rxParams->txMobility = txMobility;
+
                     if (rxParams->txAntenna)
                     {
                         Angles txAngles(receiverMobility->GetPosition(), txMobility->GetPosition());
@@ -413,7 +424,7 @@
         }
     }
 
-    auto txMobility = params->txPhy->GetMobility();
+    auto txMobility = params->txMobility;
     auto rxMobility = receiver->GetMobility();
     if (txMobility && rxMobility)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/single-model-spectrum-channel.cc ns-3.46/src/spectrum/model/single-model-spectrum-channel.cc
--- ns-3.45/src/spectrum/model/single-model-spectrum-channel.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/model/single-model-spectrum-channel.cc	2025-10-01 18:46:32.000000000 -0700
@@ -11,6 +11,7 @@
 #include "spectrum-phy.h"
 #include "spectrum-propagation-loss-model.h"
 #include "spectrum-transmit-filter.h"
+#include "wraparound-model.h"
 
 #include "ns3/angles.h"
 #include "ns3/antenna-model.h"
@@ -111,7 +112,9 @@
         NS_ASSERT(*(txParams->psd->GetSpectrumModel()) == *m_spectrumModel);
     }
 
-    Ptr<MobilityModel> senderMobility = txParams->txPhy->GetMobility();
+    auto wraparound = GetObject<WraparoundModel>();
+    Ptr<MobilityModel> refSenderMobility = txParams->txPhy->GetMobility();
+    Ptr<MobilityModel> senderMobility = refSenderMobility;
 
     for (auto rxPhyIterator = m_phyList.begin(); rxPhyIterator != m_phyList.end(); ++rxPhyIterator)
     {
@@ -144,6 +147,14 @@
 
             if (senderMobility && receiverMobility)
             {
+                if (wraparound)
+                {
+                    // Use virtual mobility model instead
+                    senderMobility =
+                        wraparound->GetVirtualMobilityModel(refSenderMobility, receiverMobility);
+                }
+                rxParams->txMobility = senderMobility;
+
                 double txAntennaGain = 0;
                 double rxAntennaGain = 0;
                 double propagationGainDb = 0;
@@ -228,7 +239,7 @@
     {
         params->psd =
             m_spectrumPropagationLoss->CalcRxPowerSpectralDensity(params,
-                                                                  params->txPhy->GetMobility(),
+                                                                  params->txMobility,
                                                                   receiver->GetMobility());
     }
     receiver->StartRx(params);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/spectrum-signal-parameters.cc ns-3.46/src/spectrum/model/spectrum-signal-parameters.cc
--- ns-3.45/src/spectrum/model/spectrum-signal-parameters.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/model/spectrum-signal-parameters.cc	2025-10-01 18:46:32.000000000 -0700
@@ -13,6 +13,7 @@
 
 #include "ns3/antenna-model.h"
 #include "ns3/log.h"
+#include "ns3/mobility-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/spectrum-signal-parameters.h ns-3.46/src/spectrum/model/spectrum-signal-parameters.h
--- ns-3.45/src/spectrum/model/spectrum-signal-parameters.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/model/spectrum-signal-parameters.h	2025-10-01 18:46:32.000000000 -0700
@@ -18,6 +18,7 @@
 class SpectrumPhy;
 class SpectrumValue;
 class AntennaModel;
+class MobilityModel;
 
 /**
  * @ingroup spectrum
@@ -113,6 +114,13 @@
      * the number of TX streams, the number of RBs.
      */
     Ptr<const ComplexMatrixArray> precodingMatrix;
+
+    /**
+     * The transmitter mobility model
+     * This should be used at StartRx instead of retrieving the mobility model directly from the
+     * PHY. This allows wraparound models to replace the real mobility model with a virtual one.
+     */
+    Ptr<MobilityModel> txMobility;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/spectrum/model/three-gpp-channel-model.h ns-3.46/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.45/src/spectrum/model/three-gpp-channel-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/spectrum/model/three-gpp-channel-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -228,21 +228,6 @@
 
     /**
      * Get the parameters needed to apply the channel generation procedure
-     * @param channelCondition the channel condition
-     * @param hBS the height of the BS
-     * @param hUT the height of the UT
-     * @param distance2D the 2D distance between tx and rx
-     * @return the parameters table
-     */
-    NS_DEPRECATED_3_41("Use GetThreeGppTable(const Ptr<const MobilityModel>, const Ptr<const "
-                       "MobilityModel>, Ptr<const ChannelCondition>) instead")
-    Ptr<const ParamsTable> GetThreeGppTable(Ptr<const ChannelCondition> channelCondition,
-                                            double hBS,
-                                            double hUT,
-                                            double distance2D) const;
-
-    /**
-     * Get the parameters needed to apply the channel generation procedure
      * @param aMob the mobility model of node A
      * @param bMob the mobility model of node B
      * @param channelCondition the channel condition
